# This is a base action that all external plugins (i.e. gems)
# should subclass

# How would I test this?
class GemPluginAction < BuildAction
  
  
  # For now I assume that the gem's templates are in the same directory as the action file
  def self.summary_template_file
    "#{File.dirname(__FILE__)}/#{command_line_action_name}_summary.html"
  end

  def self.detailed_template_file
    "#{File.dirname(__FILE__)}/#{command_line_action_name}_detailed.html"
  end

  def self.load_external_gems
    require 'rubygems'
    # Here we do stuff with the gem api to find all external gems that require kwala.
    # We will assume that they are actions and require them
    # Thanks to Chad Fowler for this bit of code
    Gem.cache.search(//).select do |specification|
      specification.dependencies.map{ |dep| dep.name }.include?('kwala')
    end.each do |depname|
      require depname.name
    end
  end

end

GemPluginAction.load_external_gems