class RailsMigrateAction < BuildAction

  def build_action(context)
    @res = `RAILS_ENV=test rake cerego:db:remigrate 2>&1`
    @success = $?.exitstatus == 0
    nres = ''
    if !@success
      # QUICK HACK as remigrate blows up on a timeout lock..
      nres = `RAILS_ENV=test rake db:migrate 2>&1`
      @success = $?.exitstatus == 0
      @res = @res + "\n ------ MIGRATE RERUN -----\n\n\n" + nres
    end

    if !@success
      raise KwalaAbortBuildException.new 
    end

    return @success
#   return unless @success
#   @res = @res +  "\n ----- MIGRATE REVERSE ----\n\n\n" + nres
#   reverse = `RAILS_ENV=test rake db:migrate VERSION=0 2>&1; echo $?`
#   unless $?.exitstatus == 0
#     # Reverse migration failed
#     @success = (reverse.index('ActiveRecord::IrreversibleMigration') != nil)
#     # Success here if and only if Migration is irreversible
#   end
#   @res = @res + reverse
#   return unless @success
#   @res = @res +  "\n ----- MIGRATE FORWARD ----\n\n\n" + nres
#   @res = `RAILS_ENV=test rake db:migrate 2>&1; echo $?`
#   @success = $?.exitstatus == 0
  end

  def score
    # success is great else fail!
    @success ? 10 : -1000
  end

  def summary_display(context)
    details_link = "<a href=\"#{context.project_name}_rails_migrate.html\">Details</a>"
    if @success
      Amrita::SanitizedString.new("<h2>MIGRATION Succeeded.</h2>#{details_link}")
    else
      Amrita::SanitizedString.new("<h2>MIGRATION FAILED !:</h2>#{details_link}")
    end
  end

  def detailed_display(context)
    det_file = "#{context.output_directory}/#{context.project_name}_rails_migrate.html"
    res = "<html><body><h1>Migration Details</h1><pre><code>#{@res}</code></pre></body></html>"
    [det_file, res]
  end

  def self.summary_template_file
    nil
  end

  def self.detailed_template_file
    nil
  end

end
