class BuildContext
  attr_accessor :project_directory, :ruby_files, :test_files
  attr_accessor :amrita_data, :ri_dir_1, :ri_dir_2, :pre_requires, :require
  attr_accessor :output_directory
  attr_accessor :vcs_num
  attr_reader :project_name

  def initialize
    @project_directory = @project_name = @ri_dir_1 = @ri_dir_2 =
    @output_directory = @require = nil
    @ruby_files = Array.new
    @test_files = Array.new
    @pre_requires = nil
    self.initialize_build_data
  end


  def initialize_build_data()
    @amrita_data = Hash.new
    @amrita_data[:project_name] = self.project_name
    @amrita_data[:build_date] = Time.now
  end

  def project_name=(project_name)
    @project_name = project_name
    @amrita_data[:project_name] = @project_name
  end

  def build_complete
    @amrita_data[:complete_time] = Time.now
    @amrita_data[:total_build_time] =  ( (@amrita_data[:complete_time] - @amrita_data[:build_date]) / 60.0 )
  end

  def vcs_info
    if @vcs_info.nil?
      # For now svn
      cur = Dir.pwd
      begin
        Dir.chdir(self.project_directory)
        @vcs_info = `svn log -r #{self.vcs_num} --verbose`
      ensure
        Dir.chdir(cur)
      end
    end

    @vcs_info
  end

end
