# Provides a method that gives instances of all of the includer's subclasses.
module InheritanceTracker

  # Returns all subclasses of calling Class.
  def get_implementors
    imps = []

    ObjectSpace.each_object(Class) do |klass|
      if klass.ancestors.include?(self)
        imps << klass
      end
    end

    # remove self from the list
    imps - [self]
  end

end

class DeepCopy
  extend Marshal

  def DeepCopy.deep_copy(obj)
    load(dump(obj))
  end

end

class String

  # Very Simple underscore implementation.
  def kwala_underscore
    self.gsub(/([A-Z])/, '_\1').downcase.gsub(/^_/, '')
  end

end
