
class Notification
  @@notifications = []

  def self.context=(context)
    @context = context
  end 

  def self.context
    @context
  end

  def self.notify(event, result, data)
    self.notifications.each { |n| n.notify(event, result, data) }
  end

  def self.add_notification(obj)
    self.notifications << obj
  end

  def self.notifications
    if @@notifications.empty?
      Dir.glob(NOTIFICATION_DIR + "/*.rb").sort.each do |file|
        begin
          require file
        rescue Exception => err
          $stderr.puts "Notification error loading #{file}", err.class, err.message
        end
      end
    end
    @@notifications
  end

  def notify(event, result = nil, data = nil)
    if self.respond_to?(event)
      self.send(event, result, data, Notification.context)
    else
      undefined_event(event, result, data, Notification.context)
    end
  end

  def undefined_event(event, result, data, context)
  end

end
