require 'net/smtp'

class EmailNotification < Notification

  def unit_test(result, data, context)
    # TODO: Probably should move this to a configuration based
    from_addr = ""
    to_addr = [ "" ]
    smtp_server = ""
    smtp_port = 25

    # Get the time and set the status msg
    now = Time.now
    status_msg = "Unit tests run #{result.to_s} at"

    # just file name for now
    data ||= {}
    data = Array(data[:filtered_results]).map do |d|
      d[:file_name]
    end

    if !data.empty?
      failure_msg = <<-MSG
Test files that reported failures:
#{data.join("\n")}
MSG
    else
      failure_msg = ''
    end

    # Create the SMTP envelope
    msgstr = <<-END_OF_MESSAGE
From: Kwala Continuous Integration <EMAIL>
To: Edge Dev Mailing List <EMAIL>
Subject: [Kwala] edge build #{context.vcs_num} #{result}
Date: #{now.strftime("%a, %d %b %Y %X +0900")}
Message-Id: <#{now.strftime("%m%d%Y%H%M%S")}@EMAIL>

Result Summary:  #{result.to_s}
See Results at https://BASEURL/kwala/

#{failure_msg}

Commit Info:
#{context.vcs_info}
    END_OF_MESSAGE

    # Send the message
    Net::SMTP.start(smtp_server, smtp_port) do |smtp|
      smtp.send_message(msgstr, from_addr, *to_addr)
    end
  end

end
